/* MAP:
1.  ZIELPLATTFORM AUSWAHL
2.  DEBUG-SCHALTER 
3.  DEFAULT-WERTE
4.  GRUNDEINSTELLUNG
5.  AKKU-KONFIGURATIONEN
6.  VERFÜGBARE HAUPTANZEIGEN
7.  SYSTEM-ZUSTÄNDE
8.  FEHLER-CODES
9.  HEIZUNGS-STEUERUNG
10. VENTILATOR-STEUERUNG
11. LCD-BELEUCHTUNGS-STEUERUNG
12. AKUSTISCHE FEHLERMELDUNGEN 
13. SPANNUNG UND STROMSENSOR 
14. I2C TEMPERATURSENSOR
15. PRÜFEN DER DEFINES
*/



/************************************* ZIELPLATTFORM AUSWAHL ************************************/
//#define LEGACY       //Kompiliert für die Legacy-Hardware
//#define COMPACT12    //Kompiliert für die Compact12
#define COMPACT24    //Kompiliert für die Compact24
//#define D4ZEILEN      //Aktiviert die 4-Zeilen-Version
//#define ENABLEPCCOM  //Aktiviert die PC Kommunikationsschnittstelle (EXPERIMENTELL)


/**************************************** DEBUG-SCHALTER ****************************************/
//#define HBDEBUG           //Wenn aktiviert gibt die HeatBox zusätzliche Debug-Informationen über Serial aus
//#define DEBUG_EEPROM      //Wenn aktiviert gibt die Bibliothek zusätzliche Debug-Informationen über Serial aus
//#define DEBUG_ENCODER     //Wenn aktiviert gibt die Bibliothek zusätzliche Debug-Informationen über Serial aus
//#define DEBUG_TEMPSENSOR  //Wenn aktiviert gibt die Bibliothek zusätzliche Debug-Informationen über Serial aus
//#define FORCE_24V         //Wenn aktiv wird die Erkennung des Betriebszustandes der Compact24 als 24V-Betrieb erzwungen
//#define FORCE_EXTERN      //Wenn aktiv wird die Erkennung des EXTERN-Modi erzwungen
#define ENABLEUSB         //Fügt "USB" in der Batterieauswahl hinzu

/************************************* DEFAULT-WERTE *************************************/
#define vorgabe_zieltemperatur         38         //Zieltemperatur
#define vorgabe_hysterese               5         //Hysterese-Bereich
#define vorgabe_batterietyp             0         //Index auf Array
#define vorgabe_zellenzahl              0         //Index auf Array
#define vorgabe_kapazitaet           5000         //Standard-Akkukapazität
#define vorgabe_abschaltgrenze       4500         //Standard-Abschaltgrenze
#define vorgabe_sollWarnen           true         //Akkuwarnung soll ausgegeben werden
#define vorgabe_warnschwelle         4000         //Akkuwarnung bei Erreichen dieser Kapazität
#define vorgabe_sollSpeichern        true         //Speichern in EEPROM
#define vorgabe_heizungLaufdauer       45         //Laufdauer der Heizung
#define vorgabe_heizungPausedauer      15         //Konvektionspausendauer der Heizung
#define vorgabe_pwmboost                0         //PWM-boost Vorgabe
#define vorgabe_ventilatorLaufdauer    10         //Laufdauer des Ventilators
#define vorgabe_ventilatorPausedauer    5         //Pausendauer des Ventilators
#define vorgabe_alarmTon             true         //Soll bei Alarmen auch ein Ton ausgegeben werden?
#define vorgabe_displayHelligkeit       5         //Helligkeit des Displays (1-10)
#define vorgabe_kalibrierWert          15         //Kalibrierungswert (in Zehntel Volt) die auf den Grundwert zur Berechnung der Spannung aufgerechnet wird (Grundwert sollte also reeller Grundwert -1,5V sein)
#define vorgabe_displayDauerAn      false         //Soll die Displaybeleuchtung permanent an bleiben?
#define vorgabe_warmhalteTemperatur    20


/*  Definiert verschiedene Schrittweiten
 *  Alle anderen Werten wird als Schrittweite "1" angenommen
 */
#define schrittweite_mah_min  10
#define schrittweite_mah_max  100
#define schrittweite_temp_min 1
#define schrittweite_temp_max 5



/**************************************** GRUNDEINSTELLUNG ****************************************/
#define defIntervallSensoren 200      //alle 200ms sollen die Sensoren abgefragt werden
#define intervallEEPROMWrite 30000    //Intervall in ms in denen der aktuelle Kapazitätsstand in das EEPROM geschrieben wird, sofern diese Option aktiviert ist
#define multiplikatorDisplay 3        //erst jedes 3. Intervall wird das Display aktualisiert (verhindert flackern)
#define multiplikatorTSensor 7        //erst jedes 7. Intervall wird der Tempsensor abgefragt
/* Die Bibliothek OneWire, welche wir für die Temperatursensor-Bibliothek nutzen
 * deaktiviert während einer Abfrage des angeschlossenen Sensors leider mehrmals
 * alle Interrupts (noInterrupt()) und aktiviert sie wieder (interrupt()). Bei zu schnell
 * aufeinanderfolgenden Abfragen werden also Tonausgabe und PWM-Erstellung immer wieder unterbrochen.
 */


#define EncoderPresstoEnterMenu 2000        //Wie viele Millisekunden muss der Encoder gedrückt gehalten sein damit das Menü geöffnet wird
#define EncoderPresstoExitCountdown 5000    //Wie viele Millisekunden muss der Encoder gedrückt gehalten sein damit der Countdown abgebrochen wird
#define bestaetigungsDauer 2000             //Wie lange soll eine Bestätigung angezeigt werden, wenn etwas optisch bestätigt werden muss (z.B. reset der Werte)
#define bildschirm1Zeit    4000             //Wie lange wird Hauptbldschirmdarstellung 1 angezeigt bevor gewechselt wird
#define bildschirm2Zeit    2500             //Wie lange wird Hauptbldschirmdarstellung 2 angezeigt bevor gewechselt wird
#define bildschirmFehlerTeilmeldung 800     //Wenn ein Fehler auftaucht, wie lange wird ein Teil der Teilmeldung angezeigt (Meldung besteht aus 2 Teilen)
#define bildschirmFehlerZeigeAnzahl 1500    //wie lange werden die zwischenmeldungen (z.B. "4 Fehler" und " - 2 von 4 -" dargestellt

#define settings_version 6


const char hbVersionString[6] = "2.0.2";
const char hbVendorString[15] = "by HaDi-RC.de";
const byte erlaubeBrandingPruefsummen[3] =  {0x96   ,  0xB2  , 0xE4};  //"  by HaDi-RC.de ", "  www.SoLeon.it "," RC-Heli-Fan.org
#define defaultBranding "  by HaDi-RC.de "    //BEI ÄNDERUNG PRÜFSUMMEN ANPASSEN!! Default-Branding das gesetzt wird, wenn das aktuelle Branding nicht erkannt wurde (oder nicht vorhanden ist). Muss 16 Zeichen lang sein (mit Leerzeichen). 

/************************************* AKKU-KONFIGURATIONEN *************************************/
#if defined(ENABLEUSB)
  #define anzahlUSB 2
  const String usb_zellen[anzahlUSB] = {"3.0V" , "4.5V"};
  const float  usb_volts[anzahlUSB] =  {3.0   ,  4.5};
#endif

#define anzahlLiIonZellen 1
const String liion_zellen[anzahlLiIonZellen] = {"3S"};
const float  liion_volts[anzahlLiIonZellen] =  {9.6};

#define anzahlNixxZellen 1
const String nixx_zellen[anzahlNixxZellen] = {"8S"};
const float  nixx_volts[anzahlNixxZellen] =  {9.5};



#if defined(LEGACY) || defined(COMPACT12)           //Für 12V-Versionen:
  #define anzahlLipoZellen 1
  const String lipo_zellen[anzahlLipoZellen] = {"3S"};
  const float  lipo_volts[anzahlLipoZellen] =  {10.2};

  #define anzahlLifeZellen 1
  const String life_zellen[anzahlLifeZellen] = {"4S"};
  const float  life_volts[anzahlLifeZellen] =  {10.8};

  #define anzahlBleiZellen 1
  const String blei_zellen[anzahlBleiZellen] = {"12V"};
  const float  blei_volts[anzahlBleiZellen] =  {11.2};
#elif defined(COMPACT24)                            //Für 24V-Versionen
  #define anzahlLipoZellen 4
  const String lipo_zellen[anzahlLipoZellen] = {"3S" , "4S" , "5S" , "6S"};
  const float  lipo_volts[anzahlLipoZellen] =  {10.2 , 13.6 , 17.5 , 21.2};

  #define anzahlLifeZellen 5
  const String life_zellen[anzahlLifeZellen] = {"4S" , "5S" , "6S" , "7S" , "8S"};
  const float  life_volts[anzahlLifeZellen] =  {10.8 , 13.3 , 16.0 , 18.6 , 21.2};

  #define anzahlBleiZellen 2
  const String blei_zellen[anzahlBleiZellen] = {"12V" , "24V"};
  const float  blei_volts[anzahlBleiZellen] =  {11.2  , 22.4};
#endif

#if defined(ENABLEUSB)
#define anzahlAkkuTypen 6
const String akku_names[anzahlAkkuTypen]       = {"USB"       ,    "LiPo"       , "LiFe"        , "LiIon"       , "NiXX"         , "Blei"};
const String *akku_zellen[anzahlAkkuTypen]     = {usb_zellen  ,    lipo_zellen  ,  life_zellen  , liion_zellen  ,   nixx_zellen  ,   blei_zellen};
const float  *akku_spannungen[anzahlAkkuTypen] = {usb_volts   ,    lipo_volts   ,  life_volts   , liion_volts   ,   nixx_volts   ,   blei_volts};

#else
#define anzahlAkkuTypen 5
const String akku_names[anzahlAkkuTypen]       = {"LiPo"       , "LiFe"        , "LiIon"       , "NiXX"         , "Blei"};
const String *akku_zellen[anzahlAkkuTypen]     = {lipo_zellen  ,  life_zellen  , liion_zellen  ,   nixx_zellen  ,   blei_zellen};
const float  *akku_spannungen[anzahlAkkuTypen] = {lipo_volts   ,  life_volts   , liion_volts   ,   nixx_volts   ,   blei_volts};

#endif



/********************************* VERFÜGBARE HAUPTANZEIGEN ********************************/
#define DISPLAY_MAIN 0
#define DISPLAY_SECONDARY 1

/************************************* SYSTEM-ZUSTÄNDE *************************************/
#define STATE_NORMAL 0
#define STATE_MENU 1
#define STATE_MENU_CHANGEVALUE 2
#define STATE_RESETAKKU 3
#define STATE_TIMERSETUP 4
#define STATE_SYSTEMSETUP 5
#define STATE_COUNTDOWN 6
#define STATE_INVALID 255


/************************************** FEHLER-CODES ***************************************/
#define ERROR_ENDSTUFE 4096
#define ERROR_NOERROR 0 
 
 
/*********************************** HEIZUNGS-STEUERUNG ************************************/
#define HEIZUNG_AUS 0                  //einfach aus
#define HEIZUNG_AN 1                   //einfach an
#define HEIZUNG_KONVEKTION 2           //konvektions-pause
#define HEIZUNG_WARTET 4               //zieltemp erreicht bzw nach erreichen noch im Hysterese-Bereich

#if defined(LEGACY)           //Für alte HeatBox:
  //Betrifft die Spannungen:                    12   13   14   15   16   17   18   19  20  21  22  23  24  25  26  27  28  29  30  31  32  33
  PROGMEM const uint8_t heizungPwmListe[22]  = {255, 224, 194, 174,  0,  0  , 0  , 0  , 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 0 , 0 , 0};
#elif defined(COMPACT12)      //Für neue HeatBox Compact24
  //Betrifft die Spannungen:                    12   13   14   15   16   17   18   19  20  21  22  23  24  25  26  27  28  29  30  31  32  33
  PROGMEM const uint8_t heizungPwmListe[22]  = {255, 224, 194, 174,  0,  0  , 0  , 0  , 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 0 , 0 , 0};
#elif defined(COMPACT24)      //Für neue HeatBox Compact24
  //Betrifft die Spannungen:                    12   13   14   15   16   17   18   19  20  21  22  23  24  25  26  27  28  29  30  31  32  33
  PROGMEM const uint8_t heizungPwmListe[22]  = {255, 224, 194, 174, 148, 133, 122, 111, 97, 89, 85, 78, 70, 63, 58, 54, 50, 45, 40, 0 , 0 , 0};
#endif




/********************************** VENTILATOR-STEUERUNG ***********************************/
#define VENTILATOR_AUS 0
#define VENTILATOR_AN 1
#define berechnePWMVentilator(volt) ((-10*volt)+325)           //PWM-Wert im 24V-Betrieb abhängig von der Spannung (pwm= (-10*spannung)+375



/******************************* LCD-BELEUCHTUNGS-STEUERUNG ********************************/
#define LED_AN 1
#define LED_AUS 0
#define LED_BLINK 2
#define LED_DELAYING 3


#define LED_AN_INTERVALL      10000     //Zeit die das Display nach dem Anschalten an bleibt
#define LED_BLINK_INTERVALL    300     //Intervallzeit für Blinken 
//#define pin_backlight          A2      //Pin für die Hintergrundbeleuchtung des Displays

#define helligkeitImMenu      128      //PWM-Einstellung für die Hintergrundbeleuchtung wenn man sich im Hauptmenü befindet (0 - 255)
#define helligkeitDauer       128
/******************************* AKUSTISCHE FEHLERMELDUNGEN ********************************/
#define ETON_PAUSE  800            //Spieldauer des ersten Tons (in ms)




/******************************* SPANNUNG UND STROMSENSOR *********************************/
/* Achtung - mit den Änderungen von 2.0.0b3 ist folgendes zu beachten:
 * Mit der Implementierung der einfachen Kalibriermethode muss von dem
 * reellen maxSpannungs-Wert 1.5V anbezogen werden.
 * Der Wert im Kalibriermenü (0-30 , default 15) wird als Zehntel Volt wieder dazu addiert.
 * So ergibt sich beim Kalibrierwert von 15 wieder der originale Wert und wir haben die Möglichkeit
 * im Bereich von -1.5V bis +1.5V zu kalibrieren
 */
#if defined(LEGACY)           //Für alte HeatBox:
  #define maxSpannung (15.0f-1.5f)   //Maximale Spannung (Auslegung Spannugnsteiler)
  #define nomSpannung 14.9f   //Nominale Spannung (erlaubte Obergrenze - darüber wird ein Fehler generiert)
#elif defined(COMPACT12)      //Für neue HeatBox Compact24
  #define maxSpannung (34.0f-1.5f)   //Maximale Spannung (Auslegung Spannugnsteiler)
  #define nomSpannung 14.9f   //Nominale Spannung (erlaubte Obergrenze - darüber wird ein Fehler generiert)
#elif defined(COMPACT24)      //Für neue HeatBox Compact24
  #define maxSpannung (34.0f-1.5f)   //Maximale Spannung (Auslegung Spannugnsteiler)
  #define nomSpannung 28.9f   //Nominale Spannung (erlaubte Obergrenze - darüber wird ein Fehler generiert)
#endif

#define spannungSchwankungVerzoegerung 2000  //Zeitraum (in ms) nach einer Über- oder Unterspannugnserkennung, die gewartet wird ob sich die Spannung erhohlt (Über- / Unterspannungsschutz mit Lastspitzenverzögerung)
#define pinIntExt A3         //An diesem Pin wird die Intern/Extern-Kennung festgelegt. Ist hier HIGH wird eine externe Versorgung angenommen.


#define maxStrom 25000       //Strom in mAh bei dem am Sensorausgang 5V anliegen würden (misst der 20A-Sensor 25A liegen dort die 5V an)
#define nomStrom 20000       //Bei Erreichen von Strömen ÜBER diesen Wert wird von einem Kurzschluss oder einer zu hohen Last ausgagenen
#define pinUSensor A1        //Pin, an dem der Spannungssensor hängt
#define pinISensor A0        //Pin, an dem der Stromsensor hängt
#define stromSchwellePause 2000 // Strom in mA der maximal in einer Heizpause gezogen werden darf. Werte darüber lösen einen Alarm aus.

/********************************** I2C TEMPERATURSENSOR ***********************************/
#define pinTSensor 9         //Pin, an dem der Temperatursensor/i2c - Bus liegt
#define TSensorAufloesung 9  //Auflösung in Bit (9, 10, 11 oder 12 Bit)

/*********************************** Datensequenznummern ***********************************/
#define DATA_HBVERSION                     0
#define DATA_TEMP_MIN                     10
#define DATA_TEMP_MAX                     11
#define DATA_TEMP                         12
#define DATA_HYSTERESE_MIN                13
#define DATA_HYSTERESE_MAX                14
#define DATA_HYSTERESE                    15
#define DATA_BATTERIE_TYP_MIN             16
#define DATA_BATTERIE_TYP_MAX             17
#define DATA_BATTERIE_TYP                 18
#define DATA_BATTERIE_LISTE               19
#define DATA_BATTERIE_ZELLEN_MIN          20
#define DATA_BATTERIE_ZELLEN_MAX          21
#define DATA_BATTERIE_ZELLEN              22
#define DATA_BATTERIE_KAPAZITAET_MIN      23
#define DATA_BATTERIE_KAPAZITAET_MAX      24
#define DATA_BATTERIE_KAPAZITAET          25
#define DATA_BATTERIE_ABSCHALTGRENZE_MIN  26
#define DATA_BATTERIE_ABSCHALTGRENZE_MAX  27
#define DATA_BATTERIE_ABSCHALTGRENZE      28
#define DATA_BATTERIE_SOLLWARNEN          29
#define DATA_BATTERIE_WARNSCHWELLE_MIN    30
#define DATA_BATTERIE_WARNSCHWELLE_MAX    31
#define DATA_BATTERIE_WARNSCHWELLE        32
#define DATA_BATTERIE_SOLLSPEICHERN       33
#define DATA_HEIZUNG_LAUFDAUER_MIN        34
#define DATA_HEIZUNG_LAUFDAUER_MAX        35
#define DATA_HEIZUNG_LAUFDAUER            36
#define DATA_HEIZUNG_PAUSEDAUER_MIN       37
#define DATA_HEIZUNG_PAUSEDAUER_MAX       38
#define DATA_HEIZUNG_PAUSEDAUER           39
#define DATA_HEIZUNG_PWMBOOST_MIN         40
#define DATA_HEIZUNG_PWMBOOST_MAX         41
#define DATA_HEIZUNG_PWMBOOST             42
#define DATA_VENTILATOR_LAUFDAUER_MIN     43
#define DATA_VENTILATOR_LAUFDAUER_MAX     44
#define DATA_VENTILATOR_LAUFDAUER         45
#define DATA_VENTILATOR_PAUSEDAUER_MIN    46
#define DATA_VENTILATOR_PAUSEDAUER_MAX    47
#define DATA_VENTILATOR_PAUSEDAUER        48
#define DATA_KALIBRIERUNG_MIN             49
#define DATA_KALIBRIERUNG_MAX             50
#define DATA_KALIBRIERUNG                 51
#define DATA_LEDHELLIGKEIT_MIN            52
#define DATA_LEDHELLIGKEIT_MAX            53
#define DATA_LEDHELLIGKEIT                54
#define DATA_VOLTAGE                      64
#define DATA_TEMPERATURE                  65
#define DATA_HEIZUNG_STATUS               66
#define STEP_MAH_MIN                      70
#define STEP_MAH_MAX                      71
#define STEP_TEMP_MIN                     72
#define STEP_TEMP_MAX                     73
#define DATA_LOAD_PRE                    252
#define DATA_LOAD_DEFAULT                253
#define DATA_SAVE                        254
#define DATA_ALL                         255	








#if defined(D4ZEILEN)
  #if defined(LEGACY)
    const char deviceInfoString[17] = "Legacy 4x16";
  #elif defined(COMPACT12)
    const char deviceInfoString[17] = "Compact 4x16";
  #elif defined(COMPACT24)
    const char deviceInfoString[17] = "Compact24 4x16";
  #endif
#else
  #if defined(LEGACY)
    const char deviceInfoString[17] = "Legacy 2x16";
  #elif defined(COMPACT12)
    const char deviceInfoString[17] = "Compact 2x16";
  #elif defined(COMPACT24)
    const char deviceInfoString[17] = "Compact24 2x16";
  #endif
#endif

/*********************************** PRÜFEN DER DEFINES ************************************/
#if defined(LEGACY)
  #if defined(FORCE_24V)
    #error "Kein FORCE_24V auf der Legacy-Heatbox erlaubt."
  #endif
  #if defined(COMPACT12) || defined(COMPACT24)
    #error "Mehrere Zielplattformen gleichzeitig definiert."
  #endif

#elif defined(COMPACT12) 
  #if defined(FORCE_24V)
    #error "Kein FORCE_24V auf COMPACT12-Heatbox erlaubt."
  #endif
  #if defined(LEGACY) || defined(COMPACT24)
    #error "Mehrere Zielplattformen gleichzeitig definiert."
  #endif

#elif defined(COMPACT24) 
  #if defined(LEGACY) || defined(COMPACT12)
    #error "Mehrere Zielplattformen gleichzeitig definiert."
  #endif
#else
  #error "Keine Zielplattform definiert."
#endif
